#include "stm32f10x.h"
#include "stdio.h"
#include "time.h"



void time3_init_it_1s(void)
 {
	TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStruct;
	NVIC_InitTypeDef NVIC_InitStruct;
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3,ENABLE);            //ʱ 2
	 
	TIM_TimeBaseInitStruct.TIM_ClockDivision=TIM_CKD_DIV1;
	TIM_TimeBaseInitStruct.TIM_CounterMode=TIM_CounterMode_Up;
	TIM_TimeBaseInitStruct.TIM_Period=9999;
	TIM_TimeBaseInitStruct.TIM_Prescaler=7199;                    //Ƶ1~65535
//	TIM_TimeBaseInitStruct.TIM_RepetitionCounter=
	TIM_TimeBaseInit(TIM3,&TIM_TimeBaseInitStruct);               //ʱ
	
	TIM_ITConfig(TIM3,TIM_IT_Update,ENABLE);                      //¼ж
	 
	NVIC_InitStruct.NVIC_IRQChannel=TIM3_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelPreemptionPriority=0x03;
	NVIC_InitStruct.NVIC_IRQChannelCmd=ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelSubPriority=0x03;
	NVIC_Init(&NVIC_InitStruct);
	 
	TIM_Cmd(TIM3,ENABLE);
}
 
void TIM3_IRQHandler()
{
	u32 i=0,j=0;
	if(TIM_GetITStatus(TIM3,TIM_IT_Update)!=RESET)
	{
		GPIO_ResetBits(GPIOE,GPIO_Pin_5);
		printf("\r\nWRONG\r\n");
	}
	TIM_ClearITPendingBit(TIM3, TIM_IT_Update  );
	for(i=0;i<9999;i++)
		for(j=0;j<199;j++);
}


void time3_pwm_init()
{
	GPIO_InitTypeDef GPIO_InitStruct;
	TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStruct;
	TIM_OCInitTypeDef TIM_OCInitStruct;
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3,ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO|RCC_APB2Periph_GPIOB,ENABLE);
	
	GPIO_PinRemapConfig(GPIO_PartialRemap_TIM3,ENABLE);
	
	GPIO_InitStruct.GPIO_Mode=GPIO_Mode_AF_PP;
	GPIO_InitStruct.GPIO_Pin=GPIO_Pin_5;
	GPIO_InitStruct.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(GPIOB,&GPIO_InitStruct);
	

	TIM_TimeBaseInitStruct.TIM_ClockDivision=TIM_CKD_DIV1;
	TIM_TimeBaseInitStruct.TIM_CounterMode=TIM_CounterMode_Up;
	TIM_TimeBaseInitStruct.TIM_Period=899;
	TIM_TimeBaseInitStruct.TIM_Prescaler=0;                    //Ƶ1~65535                   9999   7199
//	TIM_TimeBaseInitStruct.TIM_RepetitionCounter=               //߼ʱŻõ
	TIM_TimeBaseInit(TIM3,&TIM_TimeBaseInitStruct);               //ʱ
	
	TIM_OCInitStruct.TIM_OCMode=TIM_OCMode_PWM2;
	TIM_OCInitStruct.TIM_OutputState=TIM_OutputState_Enable;
	TIM_OCInitStruct.TIM_OCPolarity=TIM_OCPolarity_High;         //϶⣬ǵ͵ƽЧ
	TIM_OC2Init(TIM3,&TIM_OCInitStruct);
	
	TIM_OC2PreloadConfig(TIM3,TIM_OCPreload_Enable);
	
	TIM_Cmd(TIM3,ENABLE);

}


void tim5_ic_in_init()
{
	TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStruct;
	TIM_ICInitTypeDef TIM_ICInitStruct;
	NVIC_InitTypeDef NVIC_InitStruct;
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM5,ENABLE);
	
	TIM_TimeBaseInitStruct.TIM_ClockDivision=TIM_CKD_DIV1;
	TIM_TimeBaseInitStruct.TIM_CounterMode=TIM_CounterMode_Up;
	TIM_TimeBaseInitStruct.TIM_Period=9999;            //arr;
	TIM_TimeBaseInitStruct.TIM_Prescaler=7199;         //psc;
	TIM_TimeBaseInit(TIM5,&TIM_TimeBaseInitStruct);

	TIM_ICInitStruct.TIM_Channel=TIM_Channel_1;
	TIM_ICInitStruct.TIM_ICSelection=TIM_ICSelection_DirectTI;
	TIM_ICInitStruct.TIM_ICPrescaler=TIM_ICPSC_DIV1;
	TIM_ICInitStruct.TIM_ICFilter=0x00;
	TIM_ICInitStruct.TIM_ICPolarity=TIM_ICPolarity_Rising;
	TIM_ICInit(TIM5,&TIM_ICInitStruct);
	
	TIM_ITConfig(TIM5,TIM_IT_CC1|TIM_IT_Update,ENABLE);
	
	NVIC_InitStruct.NVIC_IRQChannel=TIM5_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd=ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPreemptionPriority=0x02;
	NVIC_InitStruct.NVIC_IRQChannelSubPriority=0x02;
	NVIC_Init(&NVIC_InitStruct);
	
	
	TIM_Cmd(TIM5,ENABLE);
}

u16 ii=0,jj=0,ll=0,mm=0;
void TIM5_IRQHandler()
{
	u16 ii=0,jj=0,ll=0,mm=0;
//	vu16 ii=0,jj=0,kk=0,ll=0,mm=0;
	if(jj==1)
	{
		if(TIM_GetITStatus(TIM5,TIM_IT_Update)!=RESET)
		{
			ii++;
		}		
	}
	if(TIM_GetITStatus(TIM5,TIM_IT_CC1)!=RESET)
	{
		if(jj==0)
		{
			jj=1;
			TIM_OC1PolarityConfig(TIM5,TIM_ICPolarity_Falling);
		}
		else
		{
			TIM_SetCounter(TIM5,0);
			ll=TIM_GetCapture1(TIM5);
			mm=ll+ii*10000;
			printf("\r\ntime:%ds %dus\r\n",ii,ll);
			printf("\r\n%d\r\n",mm);
			ii=0;
			jj=0;
			TIM_OC1PolarityConfig(TIM5,TIM_OCPolarity_High);
		}
	}
	TIM_ClearITPendingBit(TIM5,TIM_IT_CC1|TIM_IT_Update);
}